use serde::{Serialize, Deserialize};

#[derive(Serialize, Deserialize)]
pub struct Actor {
  pub context: Vec<String>,
  pub id: String,
  #[serde(rename = "type")]
  pub type_: String,
  pub preferred_username: String,
  pub inbox: String,
  pub outbox: String,
  pub public_key: PublicKey,
}

#[derive(Serialize, Deserialize)]
pub struct PublicKey {
  pub id: String,
  pub owner: String,
  pub public_key_pem: String,
}

impl Actor {
  pub fn default_context() -> Vec<String> {
    vec![
      "https://www.w3.org/ns/activitystreams".to_owned(),
      "https://w3id.org/security/v1".to_owned(),
    ]
  }
}
