use super::user;

pub trait DB : Send + Sync {
  fn new(&self, d: &user::Id) -> Result<(), String>;
  fn delete(&self, d: &user::Id) -> Result<(), String>;
  fn exists(&self, d: &user::Id) -> Result<bool, String>;

  fn get_profile(&self, id: &user::Id) -> Result<user::Profile, ReadError>;
  fn set_profile(&self, id: &user::Id, d: user::Profile) -> Result<user::Profile, WriteError>;
}

pub enum ReadError {
  Missing,
  Internal(String),
}
pub enum WriteError {
  Missing,
  Violation,
  Internal(String),
}
